/* completion.c generated by valac 0.56.17, the Vala compiler
 * generated from completion.vala, do not modify */

/* Completion facility functions

   Copyright (c) 1997-2020 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_COMPLETION (completion_get_type ())
#define COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION, Completion))
#define COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION, CompletionClass))
#define IS_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION))
#define IS_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION))
#define COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION, CompletionClass))

typedef struct _Completion Completion;
typedef struct _CompletionClass CompletionClass;
typedef struct _CompletionPrivate CompletionPrivate;

#define TYPE_BUFFER (buffer_get_type ())
#define BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUFFER, Buffer))
#define BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUFFER, BufferClass))
#define IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUFFER))
#define IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUFFER))
#define BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUFFER, BufferClass))

typedef struct _Buffer Buffer;
typedef struct _BufferClass BufferClass;
typedef enum  {
	COMPLETION_FLAGS_POPPEDUP = 1 << 0,
	COMPLETION_FLAGS_CLOSE = 1 << 1,
	COMPLETION_FLAGS_FILENAME = 1 << 2
} CompletionFlags;

#define COMPLETION_TYPE_FLAGS (completion_flags_get_type ())
typedef enum  {
	COMPLETION_CODE_notmatched,
	COMPLETION_CODE_matched,
	COMPLETION_CODE_matchednonunique,
	COMPLETION_CODE_nonunique
} CompletionCode;

#define COMPLETION_TYPE_CODE (completion_code_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _buffer_unref0(var) ((var == NULL) ? NULL : (var = (buffer_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_WINDOW (window_get_type ())
#define WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WINDOW, Window))
#define WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WINDOW, WindowClass))
#define IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WINDOW))
#define IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WINDOW))
#define WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WINDOW, WindowClass))

typedef struct _Window Window;
typedef struct _WindowClass WindowClass;
#define _window_unref0(var) ((var == NULL) ? NULL : (var = (window_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _completion_unref0(var) ((var == NULL) ? NULL : (var = (completion_unref (var), NULL)))
typedef struct _WindowPrivate WindowPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define MARKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MARKER, MarkerClass))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define IS_MARKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MARKER))
#define MARKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MARKER, MarkerClass))

typedef struct _Marker Marker;
typedef struct _MarkerClass MarkerClass;
typedef void (*BufferWriter) (gpointer user_data);
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
typedef struct _ParamSpecCompletion ParamSpecCompletion;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Completion {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CompletionPrivate * priv;
	gchar* match;
	Buffer* old_bp;
	GeeSortedSet* completions;
	GeeSortedSet* matches;
	glong matchsize;
	CompletionFlags flags;
	gchar* path;
};

struct _CompletionClass {
	GTypeClass parent_class;
	void (*finalize) (Completion *self);
};

struct _Block4Data {
	int _ref_count_;
	Completion* self;
	GeeSortedSet* l;
};

struct _Window {
	GTypeInstance parent_instance;
	volatile int ref_count;
	WindowPrivate * priv;
	Window* next;
	Buffer* bp;
	gsize topdelta;
	gsize start_column;
	Marker* saved_pt;
	gsize fwidth;
	gsize fheight;
	gsize ewidth;
	gsize eheight;
	gboolean all_displayed;
	gsize lastpointn;
};

struct _WindowClass {
	GTypeClass parent_class;
	void (*finalize) (Window *self);
};

struct _ParamSpecCompletion {
	GParamSpec parent_instance;
};

static gpointer completion_parent_class = NULL;
VALA_EXTERN Window* cur_wp;
VALA_EXTERN Window* head_wp;
VALA_EXTERN Buffer* cur_bp;

VALA_EXTERN gpointer completion_ref (gpointer instance);
VALA_EXTERN void completion_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_completion (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_completion (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_completion (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_completion (const GValue* value);
VALA_EXTERN GType completion_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Completion, completion_unref)
VALA_EXTERN gpointer buffer_ref (gpointer instance);
VALA_EXTERN void buffer_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_buffer (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_buffer (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_buffer (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_buffer (const GValue* value);
VALA_EXTERN GType buffer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Buffer, buffer_unref)
VALA_EXTERN GType completion_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType completion_code_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Completion* completion_new (gboolean fileflag);
VALA_EXTERN Completion* completion_construct (GType object_type,
                                  gboolean fileflag);
VALA_EXTERN void completion_scroll_up (void);
VALA_EXTERN gpointer window_ref (gpointer instance);
VALA_EXTERN void window_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_window (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_window (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_window (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_window (const GValue* value);
VALA_EXTERN GType window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Window, window_unref)
VALA_EXTERN Window* window_find (const gchar* name);
VALA_EXTERN void window_set_current (Window* self);
VALA_EXTERN gboolean funcall (const gchar* name,
                  glong* maybe_uniarg,
                  GeeQueue* args);
VALA_EXTERN void window_resync (Window* self);
VALA_EXTERN void term_redisplay (void);
VALA_EXTERN void completion_scroll_down (void);
static guint completion_max_length (GeeTraversable* l);
static guint __lambda5_ (gchar* s,
                  guint maxlen);
static gpointer ___lambda5__gee_fold_func (gpointer g,
                                    gpointer a,
                                    gpointer self);
static void completion_popup_completion (Completion* self,
                                  gboolean allflag);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN gpointer marker_ref (gpointer instance);
VALA_EXTERN void marker_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_marker (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_marker (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_marker (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_marker (const GValue* value);
VALA_EXTERN GType marker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Marker, marker_unref)
VALA_EXTERN void write_temp_buffer (const gchar* name,
                        gboolean show,
                        BufferWriter func,
                        gpointer func_target);
static void __lambda6_ (Block4Data* _data4_);
VALA_EXTERN void bprintf (const gchar* fmt,
              ...);
VALA_EXTERN gboolean insert_newline (void);
static void ___lambda6__buffer_writer (gpointer self);
static gchar* completion_readdir (Completion* self,
                           const gchar* in_path);
VALA_EXTERN gchar* expand_path (const gchar* path);
VALA_EXTERN gchar* compact_path (const gchar* in_path);
VALA_EXTERN CompletionCode completion_try (Completion* self,
                               const gchar* in_search,
                               gboolean popup_when_complete);
static void completion_finalize (Completion * obj);
static GType completion_get_type_once (void);

static GType
completion_code_get_type_once (void)
{
	static const GEnumValue values[] = {{COMPLETION_CODE_notmatched, "COMPLETION_CODE_notmatched", "notmatched"}, {COMPLETION_CODE_matched, "COMPLETION_CODE_matched", "matched"}, {COMPLETION_CODE_matchednonunique, "COMPLETION_CODE_matchednonunique", "matchednonunique"}, {COMPLETION_CODE_nonunique, "COMPLETION_CODE_nonunique", "nonunique"}, {0, NULL, NULL}};
	GType completion_code_type_id;
	completion_code_type_id = g_enum_register_static ("CompletionCode", values);
	return completion_code_type_id;
}

GType
completion_code_get_type (void)
{
	static volatile gsize completion_code_type_id__once = 0;
	if (g_once_init_enter (&completion_code_type_id__once)) {
		GType completion_code_type_id;
		completion_code_type_id = completion_code_get_type_once ();
		g_once_init_leave (&completion_code_type_id__once, completion_code_type_id);
	}
	return completion_code_type_id__once;
}

static GType
completion_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{COMPLETION_FLAGS_POPPEDUP, "COMPLETION_FLAGS_POPPEDUP", "poppedup"}, {COMPLETION_FLAGS_CLOSE, "COMPLETION_FLAGS_CLOSE", "close"}, {COMPLETION_FLAGS_FILENAME, "COMPLETION_FLAGS_FILENAME", "filename"}, {0, NULL, NULL}};
	GType completion_flags_type_id;
	completion_flags_type_id = g_flags_register_static ("CompletionFlags", values);
	return completion_flags_type_id;
}

GType
completion_flags_get_type (void)
{
	static volatile gsize completion_flags_type_id__once = 0;
	if (g_once_init_enter (&completion_flags_type_id__once)) {
		GType completion_flags_type_id;
		completion_flags_type_id = completion_flags_get_type_once ();
		g_once_init_leave (&completion_flags_type_id__once, completion_flags_type_id);
	}
	return completion_flags_type_id__once;
}

Completion*
completion_construct (GType object_type,
                      gboolean fileflag)
{
	Completion* self = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
#line 45 "src/completion.vala"
	self = (Completion*) g_type_create_instance (object_type);
#line 46 "src/completion.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 46 "src/completion.vala"
	_g_object_unref0 (self->completions);
#line 46 "src/completion.vala"
	self->completions = (GeeSortedSet*) _tmp0_;
#line 47 "src/completion.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 47 "src/completion.vala"
	_g_object_unref0 (self->matches);
#line 47 "src/completion.vala"
	self->matches = (GeeSortedSet*) _tmp1_;
#line 49 "src/completion.vala"
	if (fileflag) {
#line 339 "completion.c"
		gchar* _tmp2_;
#line 50 "src/completion.vala"
		_tmp2_ = g_strdup ("");
#line 50 "src/completion.vala"
		_g_free0 (self->path);
#line 50 "src/completion.vala"
		self->path = _tmp2_;
#line 51 "src/completion.vala"
		self->flags = self->flags | COMPLETION_FLAGS_FILENAME;
#line 349 "completion.c"
	}
#line 45 "src/completion.vala"
	return self;
#line 353 "completion.c"
}

Completion*
completion_new (gboolean fileflag)
{
#line 45 "src/completion.vala"
	return completion_construct (TYPE_COMPLETION, fileflag);
#line 361 "completion.c"
}

static gpointer
_window_ref0 (gpointer self)
{
#line 56 "src/completion.vala"
	return self ? window_ref (self) : NULL;
#line 369 "completion.c"
}

void
completion_scroll_up (void)
{
	Window* old_wp = NULL;
	Window* _tmp0_;
	Window* _tmp1_;
	Window* wp = NULL;
	Window* _tmp2_;
	Window* _tmp3_;
	Window* _tmp4_;
	Window* _tmp6_;
#line 56 "src/completion.vala"
	_tmp0_ = cur_wp;
#line 56 "src/completion.vala"
	_tmp1_ = _window_ref0 (_tmp0_);
#line 56 "src/completion.vala"
	old_wp = _tmp1_;
#line 57 "src/completion.vala"
	_tmp2_ = window_find ("*Completions*");
#line 57 "src/completion.vala"
	wp = _tmp2_;
#line 58 "src/completion.vala"
	_tmp3_ = wp;
#line 58 "src/completion.vala"
	_vala_assert (_tmp3_ != NULL, "wp != null");
#line 59 "src/completion.vala"
	_tmp4_ = wp;
#line 59 "src/completion.vala"
	window_set_current (_tmp4_);
#line 60 "src/completion.vala"
	if (funcall ("scroll-up", NULL, NULL) == FALSE) {
#line 403 "completion.c"
		Window* _tmp5_;
#line 61 "src/completion.vala"
		funcall ("beginning-of-buffer", NULL, NULL);
#line 62 "src/completion.vala"
		_tmp5_ = cur_wp;
#line 62 "src/completion.vala"
		window_resync (_tmp5_);
#line 411 "completion.c"
	}
#line 64 "src/completion.vala"
	_tmp6_ = old_wp;
#line 64 "src/completion.vala"
	window_set_current (_tmp6_);
#line 66 "src/completion.vala"
	term_redisplay ();
#line 55 "src/completion.vala"
	_window_unref0 (wp);
#line 55 "src/completion.vala"
	_window_unref0 (old_wp);
#line 423 "completion.c"
}

void
completion_scroll_down (void)
{
	Window* old_wp = NULL;
	Window* _tmp0_;
	Window* _tmp1_;
	Window* wp = NULL;
	Window* _tmp2_;
	Window* _tmp3_;
	Window* _tmp4_;
	Window* _tmp6_;
#line 70 "src/completion.vala"
	_tmp0_ = cur_wp;
#line 70 "src/completion.vala"
	_tmp1_ = _window_ref0 (_tmp0_);
#line 70 "src/completion.vala"
	old_wp = _tmp1_;
#line 71 "src/completion.vala"
	_tmp2_ = window_find ("*Completions*");
#line 71 "src/completion.vala"
	wp = _tmp2_;
#line 72 "src/completion.vala"
	_tmp3_ = wp;
#line 72 "src/completion.vala"
	_vala_assert (_tmp3_ != NULL, "wp != null");
#line 73 "src/completion.vala"
	_tmp4_ = wp;
#line 73 "src/completion.vala"
	window_set_current (_tmp4_);
#line 74 "src/completion.vala"
	if (funcall ("scroll-down", NULL, NULL) == FALSE) {
#line 457 "completion.c"
		Window* _tmp5_;
#line 75 "src/completion.vala"
		funcall ("end-of-buffer", NULL, NULL);
#line 76 "src/completion.vala"
		_tmp5_ = cur_wp;
#line 76 "src/completion.vala"
		window_resync (_tmp5_);
#line 465 "completion.c"
	}
#line 78 "src/completion.vala"
	_tmp6_ = old_wp;
#line 78 "src/completion.vala"
	window_set_current (_tmp6_);
#line 80 "src/completion.vala"
	term_redisplay ();
#line 69 "src/completion.vala"
	_window_unref0 (wp);
#line 69 "src/completion.vala"
	_window_unref0 (old_wp);
#line 477 "completion.c"
}

static guint
__lambda5_ (gchar* s,
            guint maxlen)
{
	gint _tmp0_;
	gint _tmp1_;
	guint result;
#line 84 "src/completion.vala"
	g_return_val_if_fail (s != NULL, 0U);
#line 85 "src/completion.vala"
	_tmp0_ = strlen (s);
#line 85 "src/completion.vala"
	_tmp1_ = _tmp0_;
#line 85 "src/completion.vala"
	result = MAX ((guint) _tmp1_, maxlen);
#line 85 "src/completion.vala"
	_g_free0 (s);
#line 85 "src/completion.vala"
	return result;
#line 499 "completion.c"
}

static gpointer
___lambda5__gee_fold_func (gpointer g,
                           gpointer a,
                           gpointer self)
{
	gpointer result;
	result = (gpointer) ((guintptr) __lambda5_ ((gchar*) g, (guint) ((guintptr) a)));
#line 84 "src/completion.vala"
	return result;
#line 511 "completion.c"
}

static guint
completion_max_length (GeeTraversable* l)
{
	gpointer _tmp0_;
	guint result;
#line 83 "src/completion.vala"
	g_return_val_if_fail (l != NULL, 0U);
#line 84 "src/completion.vala"
	_tmp0_ = gee_traversable_fold (l, G_TYPE_UINT, NULL, NULL, ___lambda5__gee_fold_func, NULL, (gpointer) ((guintptr) 0U));
#line 84 "src/completion.vala"
	result = (guint) ((guintptr) _tmp0_);
#line 84 "src/completion.vala"
	return result;
#line 527 "completion.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 89 "src/completion.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 89 "src/completion.vala"
	return _data4_;
#line 537 "completion.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 89 "src/completion.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 547 "completion.c"
		Completion* self;
#line 89 "src/completion.vala"
		self = _data4_->self;
#line 89 "src/completion.vala"
		_completion_unref0 (self);
#line 89 "src/completion.vala"
		g_slice_free (Block4Data, _data4_);
#line 555 "completion.c"
	}
}

static void
__lambda6_ (Block4Data* _data4_)
{
	Completion* self;
	guint max = 0U;
	GeeSortedSet* _tmp0_;
	guint numcols = 0U;
	Window* _tmp1_;
	guint col = 0U;
#line 97 "src/completion.vala"
	self = _data4_->self;
#line 99 "src/completion.vala"
	_tmp0_ = _data4_->l;
#line 99 "src/completion.vala"
	max = completion_max_length ((GeeTraversable*) _tmp0_) + 5;
#line 100 "src/completion.vala"
	_tmp1_ = cur_wp;
#line 100 "src/completion.vala"
	numcols = (((guint) _tmp1_->ewidth) - 1) / max;
#line 102 "src/completion.vala"
	bprintf ("Possible completions are:\n", NULL);
#line 103 "src/completion.vala"
	col = (guint) 0;
#line 582 "completion.c"
	{
		GeeIterator* _s_it = NULL;
		GeeSortedSet* _tmp2_;
		GeeIterator* _tmp3_;
#line 104 "src/completion.vala"
		_tmp2_ = _data4_->l;
#line 104 "src/completion.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 104 "src/completion.vala"
		_s_it = _tmp3_;
#line 104 "src/completion.vala"
		while (TRUE) {
#line 595 "completion.c"
			GeeIterator* _tmp4_;
			gchar* s = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			const gchar* _tmp7_;
#line 104 "src/completion.vala"
			_tmp4_ = _s_it;
#line 104 "src/completion.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 104 "src/completion.vala"
				break;
#line 607 "completion.c"
			}
#line 104 "src/completion.vala"
			_tmp5_ = _s_it;
#line 104 "src/completion.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 104 "src/completion.vala"
			s = (gchar*) _tmp6_;
#line 105 "src/completion.vala"
			_tmp7_ = s;
#line 105 "src/completion.vala"
			bprintf ("%-*s", (gint) max, _tmp7_, NULL);
#line 107 "src/completion.vala"
			col = (col + 1) % numcols;
#line 108 "src/completion.vala"
			if (col == ((guint) 0)) {
#line 109 "src/completion.vala"
				insert_newline ();
#line 625 "completion.c"
			}
#line 104 "src/completion.vala"
			_g_free0 (s);
#line 629 "completion.c"
		}
#line 104 "src/completion.vala"
		_g_object_unref0 (_s_it);
#line 633 "completion.c"
	}
}

static void
___lambda6__buffer_writer (gpointer self)
{
#line 95 "src/completion.vala"
	__lambda6_ (self);
#line 642 "completion.c"
}

static gpointer
_buffer_ref0 (gpointer self)
{
#line 114 "src/completion.vala"
	return self ? buffer_ref (self) : NULL;
#line 650 "completion.c"
}

static void
completion_popup_completion (Completion* self,
                             gboolean allflag)
{
	Block4Data* _data4_;
	Window* _tmp0_;
	Window* _tmp1_;
	GeeSortedSet* _tmp2_ = NULL;
#line 89 "src/completion.vala"
	g_return_if_fail (self != NULL);
#line 89 "src/completion.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 89 "src/completion.vala"
	_data4_->_ref_count_ = 1;
#line 89 "src/completion.vala"
	_data4_->self = completion_ref (self);
#line 90 "src/completion.vala"
	self->flags = self->flags | COMPLETION_FLAGS_POPPEDUP;
#line 91 "src/completion.vala"
	_tmp0_ = head_wp;
#line 91 "src/completion.vala"
	_tmp1_ = _tmp0_->next;
#line 91 "src/completion.vala"
	if (_tmp1_ == NULL) {
#line 92 "src/completion.vala"
		self->flags = self->flags | COMPLETION_FLAGS_CLOSE;
#line 679 "completion.c"
	}
#line 94 "src/completion.vala"
	if (allflag) {
#line 683 "completion.c"
		GeeSortedSet* _tmp3_;
#line 94 "src/completion.vala"
		_tmp3_ = self->completions;
#line 94 "src/completion.vala"
		_tmp2_ = _tmp3_;
#line 689 "completion.c"
	} else {
		GeeSortedSet* _tmp4_;
#line 94 "src/completion.vala"
		_tmp4_ = self->matches;
#line 94 "src/completion.vala"
		_tmp2_ = _tmp4_;
#line 696 "completion.c"
	}
#line 94 "src/completion.vala"
	_data4_->l = _tmp2_;
#line 95 "src/completion.vala"
	write_temp_buffer ("*Completions*", TRUE, ___lambda6__buffer_writer, _data4_);
#line 113 "src/completion.vala"
	if ((self->flags & COMPLETION_FLAGS_CLOSE) == COMPLETION_FLAGS_CLOSE) {
#line 704 "completion.c"
		Buffer* _tmp5_;
		Buffer* _tmp6_;
#line 114 "src/completion.vala"
		_tmp5_ = cur_bp;
#line 114 "src/completion.vala"
		_tmp6_ = _buffer_ref0 (_tmp5_);
#line 114 "src/completion.vala"
		_buffer_unref0 (self->old_bp);
#line 114 "src/completion.vala"
		self->old_bp = _tmp6_;
#line 715 "completion.c"
	}
#line 116 "src/completion.vala"
	term_redisplay ();
#line 89 "src/completion.vala"
	block4_data_unref (_data4_);
#line 89 "src/completion.vala"
	_data4_ = NULL;
#line 723 "completion.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 740 "completion.c"
}

static gchar*
completion_readdir (Completion* self,
                    const gchar* in_path)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	GeeTreeSet* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* pdir = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GDir* dir = NULL;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_ = NULL;
	GDir* _tmp40_;
	gchar* _tmp42_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 122 "src/completion.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "src/completion.vala"
	g_return_val_if_fail (in_path != NULL, NULL);
#line 123 "src/completion.vala"
	_tmp0_ = g_strdup (in_path);
#line 123 "src/completion.vala"
	path = _tmp0_;
#line 124 "src/completion.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 124 "src/completion.vala"
	_g_object_unref0 (self->completions);
#line 124 "src/completion.vala"
	self->completions = (GeeSortedSet*) _tmp1_;
#line 126 "src/completion.vala"
	_tmp2_ = path;
#line 126 "src/completion.vala"
	_tmp3_ = expand_path (_tmp2_);
#line 126 "src/completion.vala"
	_g_free0 (path);
#line 126 "src/completion.vala"
	path = _tmp3_;
#line 126 "src/completion.vala"
	_tmp4_ = path;
#line 126 "src/completion.vala"
	if (_tmp4_ == NULL) {
#line 127 "src/completion.vala"
		result = NULL;
#line 127 "src/completion.vala"
		_g_free0 (path);
#line 127 "src/completion.vala"
		return result;
#line 798 "completion.c"
	}
#line 132 "src/completion.vala"
	_tmp5_ = path;
#line 132 "src/completion.vala"
	_tmp6_ = path;
#line 132 "src/completion.vala"
	_tmp7_ = strlen (_tmp6_);
#line 132 "src/completion.vala"
	_tmp8_ = _tmp7_;
#line 132 "src/completion.vala"
	if (string_get (_tmp5_, (glong) (_tmp8_ - 1)) != '/') {
#line 810 "completion.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 133 "src/completion.vala"
		_tmp9_ = path;
#line 133 "src/completion.vala"
		_tmp10_ = g_path_get_dirname (_tmp9_);
#line 133 "src/completion.vala"
		_g_free0 (pdir);
#line 133 "src/completion.vala"
		pdir = _tmp10_;
#line 134 "src/completion.vala"
		_tmp11_ = pdir;
#line 134 "src/completion.vala"
		if (g_strcmp0 (_tmp11_, "/") != 0) {
#line 828 "completion.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 135 "src/completion.vala"
			_tmp12_ = pdir;
#line 135 "src/completion.vala"
			_tmp13_ = g_strconcat (_tmp12_, "/", NULL);
#line 135 "src/completion.vala"
			_g_free0 (pdir);
#line 135 "src/completion.vala"
			pdir = _tmp13_;
#line 839 "completion.c"
		}
#line 136 "src/completion.vala"
		_tmp14_ = path;
#line 136 "src/completion.vala"
		_tmp15_ = g_path_get_basename (_tmp14_);
#line 136 "src/completion.vala"
		_g_free0 (path);
#line 136 "src/completion.vala"
		path = _tmp15_;
#line 849 "completion.c"
	} else {
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 138 "src/completion.vala"
		_tmp16_ = path;
#line 138 "src/completion.vala"
		_tmp17_ = g_strdup (_tmp16_);
#line 138 "src/completion.vala"
		_g_free0 (pdir);
#line 138 "src/completion.vala"
		pdir = _tmp17_;
#line 139 "src/completion.vala"
		_tmp18_ = g_strdup ("");
#line 139 "src/completion.vala"
		_g_free0 (path);
#line 139 "src/completion.vala"
		path = _tmp18_;
#line 868 "completion.c"
	}
#line 142 "src/completion.vala"
	dir = NULL;
#line 872 "completion.c"
	{
		GDir* _tmp19_ = NULL;
		const gchar* _tmp20_;
		GDir* _tmp21_;
		GDir* _tmp22_;
		gchar* name = NULL;
#line 144 "src/completion.vala"
		_tmp20_ = pdir;
#line 144 "src/completion.vala"
		_tmp21_ = g_dir_open (_tmp20_, (guint) 0, &_inner_error0_);
#line 144 "src/completion.vala"
		_tmp19_ = _tmp21_;
#line 144 "src/completion.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "src/completion.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 889 "completion.c"
				goto __catch0_g_file_error;
			}
#line 144 "src/completion.vala"
			_g_dir_close0 (dir);
#line 144 "src/completion.vala"
			_g_free0 (pdir);
#line 144 "src/completion.vala"
			_g_free0 (path);
#line 144 "src/completion.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "src/completion.vala"
			g_clear_error (&_inner_error0_);
#line 144 "src/completion.vala"
			return NULL;
#line 904 "completion.c"
		}
#line 144 "src/completion.vala"
		_tmp22_ = _tmp19_;
#line 144 "src/completion.vala"
		_tmp19_ = NULL;
#line 144 "src/completion.vala"
		_g_dir_close0 (dir);
#line 144 "src/completion.vala"
		dir = _tmp22_;
#line 145 "src/completion.vala"
		name = NULL;
#line 146 "src/completion.vala"
		while (TRUE) {
#line 918 "completion.c"
			GDir* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			const gchar* _tmp26_;
			gchar* p = NULL;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* s = NULL;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			const gchar* _tmp32_;
			GeeSortedSet* _tmp35_;
			const gchar* _tmp36_;
#line 146 "src/completion.vala"
			_tmp23_ = dir;
#line 146 "src/completion.vala"
			_tmp24_ = g_dir_read_name (_tmp23_);
#line 146 "src/completion.vala"
			_tmp25_ = g_strdup (_tmp24_);
#line 146 "src/completion.vala"
			_g_free0 (name);
#line 146 "src/completion.vala"
			name = _tmp25_;
#line 146 "src/completion.vala"
			_tmp26_ = name;
#line 146 "src/completion.vala"
			if (!(_tmp26_ != NULL)) {
#line 146 "src/completion.vala"
				break;
#line 949 "completion.c"
			}
#line 147 "src/completion.vala"
			_tmp27_ = pdir;
#line 147 "src/completion.vala"
			_tmp28_ = name;
#line 147 "src/completion.vala"
			_tmp29_ = g_build_filename (_tmp27_, _tmp28_, NULL);
#line 147 "src/completion.vala"
			p = _tmp29_;
#line 148 "src/completion.vala"
			_tmp30_ = name;
#line 148 "src/completion.vala"
			_tmp31_ = g_strdup (_tmp30_);
#line 148 "src/completion.vala"
			s = _tmp31_;
#line 149 "src/completion.vala"
			_tmp32_ = p;
#line 149 "src/completion.vala"
			if (g_file_test (_tmp32_, G_FILE_TEST_IS_DIR)) {
#line 969 "completion.c"
				const gchar* _tmp33_;
				gchar* _tmp34_;
#line 150 "src/completion.vala"
				_tmp33_ = s;
#line 150 "src/completion.vala"
				_tmp34_ = g_strconcat (_tmp33_, "/", NULL);
#line 150 "src/completion.vala"
				_g_free0 (s);
#line 150 "src/completion.vala"
				s = _tmp34_;
#line 980 "completion.c"
			}
#line 151 "src/completion.vala"
			_tmp35_ = self->completions;
#line 151 "src/completion.vala"
			_tmp36_ = s;
#line 151 "src/completion.vala"
			gee_collection_add ((GeeCollection*) _tmp35_, _tmp36_);
#line 146 "src/completion.vala"
			_g_free0 (s);
#line 146 "src/completion.vala"
			_g_free0 (p);
#line 992 "completion.c"
		}
#line 143 "src/completion.vala"
		_g_free0 (name);
#line 143 "src/completion.vala"
		_g_dir_close0 (_tmp19_);
#line 998 "completion.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 143 "src/completion.vala"
		g_clear_error (&_inner_error0_);
#line 1005 "completion.c"
	}
	__finally0:
#line 143 "src/completion.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "src/completion.vala"
		_g_dir_close0 (dir);
#line 143 "src/completion.vala"
		_g_free0 (pdir);
#line 143 "src/completion.vala"
		_g_free0 (path);
#line 143 "src/completion.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "src/completion.vala"
		g_clear_error (&_inner_error0_);
#line 143 "src/completion.vala"
		return NULL;
#line 1022 "completion.c"
	}
#line 155 "src/completion.vala"
	_tmp37_ = pdir;
#line 155 "src/completion.vala"
	_tmp38_ = compact_path (_tmp37_);
#line 155 "src/completion.vala"
	_g_free0 (self->path);
#line 155 "src/completion.vala"
	self->path = _tmp38_;
#line 157 "src/completion.vala"
	_tmp40_ = dir;
#line 157 "src/completion.vala"
	if (_tmp40_ != NULL) {
#line 1036 "completion.c"
		const gchar* _tmp41_;
#line 157 "src/completion.vala"
		_tmp41_ = path;
#line 157 "src/completion.vala"
		_tmp39_ = _tmp41_;
#line 1042 "completion.c"
	} else {
#line 157 "src/completion.vala"
		_tmp39_ = NULL;
#line 1046 "completion.c"
	}
#line 157 "src/completion.vala"
	_tmp42_ = g_strdup (_tmp39_);
#line 157 "src/completion.vala"
	result = _tmp42_;
#line 157 "src/completion.vala"
	_g_dir_close0 (dir);
#line 157 "src/completion.vala"
	_g_free0 (pdir);
#line 157 "src/completion.vala"
	_g_free0 (path);
#line 157 "src/completion.vala"
	return result;
#line 1060 "completion.c"
}

CompletionCode
completion_try (Completion* self,
                const gchar* in_search,
                gboolean popup_when_complete)
{
	gchar* search = NULL;
	gchar* _tmp0_;
	GeeTreeSet* _tmp1_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gsize fullmatches = 0UL;
	GeeSortedSet* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	CompletionCode result;
#line 163 "src/completion.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 163 "src/completion.vala"
	g_return_val_if_fail (in_search != NULL, 0);
#line 164 "src/completion.vala"
	_tmp0_ = g_strdup (in_search);
#line 164 "src/completion.vala"
	search = _tmp0_;
#line 165 "src/completion.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 165 "src/completion.vala"
	_g_object_unref0 (self->matches);
#line 165 "src/completion.vala"
	self->matches = (GeeSortedSet*) _tmp1_;
#line 167 "src/completion.vala"
	if ((self->flags & COMPLETION_FLAGS_FILENAME) == COMPLETION_FLAGS_FILENAME) {
#line 1095 "completion.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
#line 168 "src/completion.vala"
		_tmp2_ = search;
#line 168 "src/completion.vala"
		_tmp3_ = completion_readdir (self, _tmp2_);
#line 168 "src/completion.vala"
		_g_free0 (search);
#line 168 "src/completion.vala"
		search = _tmp3_;
#line 168 "src/completion.vala"
		_tmp4_ = search;
#line 168 "src/completion.vala"
		if (_tmp4_ == NULL) {
#line 169 "src/completion.vala"
			result = COMPLETION_CODE_notmatched;
#line 169 "src/completion.vala"
			_g_free0 (search);
#line 169 "src/completion.vala"
			return result;
#line 1117 "completion.c"
		}
	}
#line 171 "src/completion.vala"
	_tmp5_ = search;
#line 171 "src/completion.vala"
	_tmp6_ = strlen (_tmp5_);
#line 171 "src/completion.vala"
	_tmp7_ = _tmp6_;
#line 171 "src/completion.vala"
	if (_tmp7_ == 0) {
#line 1128 "completion.c"
		GeeSortedSet* _tmp8_;
		gpointer _tmp9_;
		GeeSortedSet* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 172 "src/completion.vala"
		_tmp8_ = self->completions;
#line 172 "src/completion.vala"
		_tmp9_ = gee_sorted_set_first (_tmp8_);
#line 172 "src/completion.vala"
		_g_free0 (self->match);
#line 172 "src/completion.vala"
		self->match = (gchar*) _tmp9_;
#line 173 "src/completion.vala"
		_tmp10_ = self->completions;
#line 173 "src/completion.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 173 "src/completion.vala"
		_tmp12_ = _tmp11_;
#line 173 "src/completion.vala"
		if (_tmp12_ > 1) {
#line 174 "src/completion.vala"
			self->matchsize = (glong) 0;
#line 175 "src/completion.vala"
			completion_popup_completion (self, TRUE);
#line 176 "src/completion.vala"
			result = COMPLETION_CODE_nonunique;
#line 176 "src/completion.vala"
			_g_free0 (search);
#line 176 "src/completion.vala"
			return result;
#line 1160 "completion.c"
		} else {
			const gchar* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 178 "src/completion.vala"
			_tmp13_ = self->match;
#line 178 "src/completion.vala"
			_tmp14_ = strlen (_tmp13_);
#line 178 "src/completion.vala"
			_tmp15_ = _tmp14_;
#line 178 "src/completion.vala"
			self->matchsize = (glong) _tmp15_;
#line 179 "src/completion.vala"
			result = COMPLETION_CODE_matched;
#line 179 "src/completion.vala"
			_g_free0 (search);
#line 179 "src/completion.vala"
			return result;
#line 1179 "completion.c"
		}
	}
#line 183 "src/completion.vala"
	fullmatches = (gsize) 0;
#line 1184 "completion.c"
	{
		GeeIterator* _s_it = NULL;
		GeeSortedSet* _tmp16_;
		GeeIterator* _tmp17_;
#line 184 "src/completion.vala"
		_tmp16_ = self->completions;
#line 184 "src/completion.vala"
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 184 "src/completion.vala"
		_s_it = _tmp17_;
#line 184 "src/completion.vala"
		while (TRUE) {
#line 1197 "completion.c"
			GeeIterator* _tmp18_;
			gchar* s = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
#line 184 "src/completion.vala"
			_tmp18_ = _s_it;
#line 184 "src/completion.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 184 "src/completion.vala"
				break;
#line 1213 "completion.c"
			}
#line 184 "src/completion.vala"
			_tmp19_ = _s_it;
#line 184 "src/completion.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 184 "src/completion.vala"
			s = (gchar*) _tmp20_;
#line 185 "src/completion.vala"
			_tmp21_ = s;
#line 185 "src/completion.vala"
			_tmp22_ = search;
#line 185 "src/completion.vala"
			_tmp23_ = search;
#line 185 "src/completion.vala"
			_tmp24_ = strlen (_tmp23_);
#line 185 "src/completion.vala"
			_tmp25_ = _tmp24_;
#line 185 "src/completion.vala"
			if (strncmp (_tmp21_, _tmp22_, (gsize) _tmp25_) == 0) {
#line 1233 "completion.c"
				GeeSortedSet* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
#line 186 "src/completion.vala"
				_tmp26_ = self->matches;
#line 186 "src/completion.vala"
				_tmp27_ = s;
#line 186 "src/completion.vala"
				gee_collection_add ((GeeCollection*) _tmp26_, _tmp27_);
#line 187 "src/completion.vala"
				_tmp28_ = s;
#line 187 "src/completion.vala"
				_tmp29_ = search;
#line 187 "src/completion.vala"
				if (g_strcmp0 (_tmp28_, _tmp29_) == 0) {
#line 1250 "completion.c"
					gsize _tmp30_;
#line 188 "src/completion.vala"
					fullmatches = fullmatches + 1;
#line 188 "src/completion.vala"
					_tmp30_ = fullmatches;
#line 1256 "completion.c"
				}
			}
#line 184 "src/completion.vala"
			_g_free0 (s);
#line 1261 "completion.c"
		}
#line 184 "src/completion.vala"
		_g_object_unref0 (_s_it);
#line 1265 "completion.c"
	}
#line 192 "src/completion.vala"
	_tmp31_ = self->matches;
#line 192 "src/completion.vala"
	_tmp32_ = gee_collection_get_size ((GeeCollection*) _tmp31_);
#line 192 "src/completion.vala"
	_tmp33_ = _tmp32_;
#line 192 "src/completion.vala"
	if (_tmp33_ == 0) {
#line 193 "src/completion.vala"
		result = COMPLETION_CODE_notmatched;
#line 193 "src/completion.vala"
		_g_free0 (search);
#line 193 "src/completion.vala"
		return result;
#line 1281 "completion.c"
	} else {
		GeeSortedSet* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
#line 194 "src/completion.vala"
		_tmp34_ = self->matches;
#line 194 "src/completion.vala"
		_tmp35_ = gee_collection_get_size ((GeeCollection*) _tmp34_);
#line 194 "src/completion.vala"
		_tmp36_ = _tmp35_;
#line 194 "src/completion.vala"
		if (_tmp36_ == 1) {
#line 1294 "completion.c"
			GeeSortedSet* _tmp37_;
			gpointer _tmp38_;
			const gchar* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
#line 195 "src/completion.vala"
			_tmp37_ = self->matches;
#line 195 "src/completion.vala"
			_tmp38_ = gee_sorted_set_first (_tmp37_);
#line 195 "src/completion.vala"
			_g_free0 (self->match);
#line 195 "src/completion.vala"
			self->match = (gchar*) _tmp38_;
#line 196 "src/completion.vala"
			_tmp39_ = self->match;
#line 196 "src/completion.vala"
			_tmp40_ = strlen (_tmp39_);
#line 196 "src/completion.vala"
			_tmp41_ = _tmp40_;
#line 196 "src/completion.vala"
			self->matchsize = (glong) _tmp41_;
#line 197 "src/completion.vala"
			result = COMPLETION_CODE_matched;
#line 197 "src/completion.vala"
			_g_free0 (search);
#line 197 "src/completion.vala"
			return result;
#line 1322 "completion.c"
		} else {
			gboolean _tmp42_ = FALSE;
			GeeSortedSet* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
#line 198 "src/completion.vala"
			_tmp43_ = self->matches;
#line 198 "src/completion.vala"
			_tmp44_ = gee_collection_get_size ((GeeCollection*) _tmp43_);
#line 198 "src/completion.vala"
			_tmp45_ = _tmp44_;
#line 198 "src/completion.vala"
			if (_tmp45_ > 1) {
#line 198 "src/completion.vala"
				_tmp42_ = fullmatches == ((gsize) 1);
#line 1338 "completion.c"
			} else {
#line 198 "src/completion.vala"
				_tmp42_ = FALSE;
#line 1342 "completion.c"
			}
#line 198 "src/completion.vala"
			if (_tmp42_) {
#line 1346 "completion.c"
				GeeSortedSet* _tmp46_;
				gpointer _tmp47_;
				const gchar* _tmp48_;
				gint _tmp49_;
				gint _tmp50_;
#line 199 "src/completion.vala"
				_tmp46_ = self->matches;
#line 199 "src/completion.vala"
				_tmp47_ = gee_sorted_set_first (_tmp46_);
#line 199 "src/completion.vala"
				_g_free0 (self->match);
#line 199 "src/completion.vala"
				self->match = (gchar*) _tmp47_;
#line 200 "src/completion.vala"
				_tmp48_ = self->match;
#line 200 "src/completion.vala"
				_tmp49_ = strlen (_tmp48_);
#line 200 "src/completion.vala"
				_tmp50_ = _tmp49_;
#line 200 "src/completion.vala"
				self->matchsize = (glong) _tmp50_;
#line 201 "src/completion.vala"
				if (popup_when_complete) {
#line 202 "src/completion.vala"
					completion_popup_completion (self, FALSE);
#line 1372 "completion.c"
				}
#line 203 "src/completion.vala"
				result = COMPLETION_CODE_matchednonunique;
#line 203 "src/completion.vala"
				_g_free0 (search);
#line 203 "src/completion.vala"
				return result;
#line 1380 "completion.c"
			}
		}
	}
	{
		guint i = 0U;
		const gchar* _tmp51_;
		gint _tmp52_;
		gint _tmp53_;
#line 206 "src/completion.vala"
		_tmp51_ = search;
#line 206 "src/completion.vala"
		_tmp52_ = strlen (_tmp51_);
#line 206 "src/completion.vala"
		_tmp53_ = _tmp52_;
#line 206 "src/completion.vala"
		i = (guint) _tmp53_;
#line 1397 "completion.c"
		{
			gboolean _tmp54_ = FALSE;
#line 206 "src/completion.vala"
			_tmp54_ = TRUE;
#line 206 "src/completion.vala"
			while (TRUE) {
#line 1404 "completion.c"
				gchar c = '\0';
				GeeSortedSet* _tmp56_;
				gpointer _tmp57_;
				gchar* _tmp58_;
				gchar _tmp59_;
#line 206 "src/completion.vala"
				if (!_tmp54_) {
#line 1412 "completion.c"
					guint _tmp55_;
#line 206 "src/completion.vala"
					i = i + 1;
#line 206 "src/completion.vala"
					_tmp55_ = i;
#line 1418 "completion.c"
				}
#line 206 "src/completion.vala"
				_tmp54_ = FALSE;
#line 207 "src/completion.vala"
				_tmp56_ = self->matches;
#line 207 "src/completion.vala"
				_tmp57_ = gee_sorted_set_first (_tmp56_);
#line 207 "src/completion.vala"
				_tmp58_ = (gchar*) _tmp57_;
#line 207 "src/completion.vala"
				_tmp59_ = string_get (_tmp58_, (glong) i);
#line 207 "src/completion.vala"
				_g_free0 (_tmp58_);
#line 207 "src/completion.vala"
				c = _tmp59_;
#line 1434 "completion.c"
				{
					GeeIterator* _s_it = NULL;
					GeeSortedSet* _tmp60_;
					GeeIterator* _tmp61_;
#line 208 "src/completion.vala"
					_tmp60_ = self->matches;
#line 208 "src/completion.vala"
					_tmp61_ = gee_iterable_iterator ((GeeIterable*) _tmp60_);
#line 208 "src/completion.vala"
					_s_it = _tmp61_;
#line 208 "src/completion.vala"
					while (TRUE) {
#line 1447 "completion.c"
						GeeIterator* _tmp62_;
						gchar* s = NULL;
						GeeIterator* _tmp63_;
						gpointer _tmp64_;
						const gchar* _tmp65_;
#line 208 "src/completion.vala"
						_tmp62_ = _s_it;
#line 208 "src/completion.vala"
						if (!gee_iterator_next (_tmp62_)) {
#line 208 "src/completion.vala"
							break;
#line 1459 "completion.c"
						}
#line 208 "src/completion.vala"
						_tmp63_ = _s_it;
#line 208 "src/completion.vala"
						_tmp64_ = gee_iterator_get (_tmp63_);
#line 208 "src/completion.vala"
						s = (gchar*) _tmp64_;
#line 209 "src/completion.vala"
						_tmp65_ = s;
#line 209 "src/completion.vala"
						if (string_get (_tmp65_, (glong) i) != c) {
#line 1471 "completion.c"
							GeeSortedSet* _tmp66_;
							gpointer _tmp67_;
#line 210 "src/completion.vala"
							_tmp66_ = self->matches;
#line 210 "src/completion.vala"
							_tmp67_ = gee_sorted_set_first (_tmp66_);
#line 210 "src/completion.vala"
							_g_free0 (self->match);
#line 210 "src/completion.vala"
							self->match = (gchar*) _tmp67_;
#line 211 "src/completion.vala"
							self->matchsize = (glong) i;
#line 212 "src/completion.vala"
							completion_popup_completion (self, FALSE);
#line 213 "src/completion.vala"
							result = COMPLETION_CODE_nonunique;
#line 213 "src/completion.vala"
							_g_free0 (s);
#line 213 "src/completion.vala"
							_g_object_unref0 (_s_it);
#line 213 "src/completion.vala"
							_g_free0 (search);
#line 213 "src/completion.vala"
							return result;
#line 1496 "completion.c"
						}
#line 208 "src/completion.vala"
						_g_free0 (s);
#line 1500 "completion.c"
					}
#line 208 "src/completion.vala"
					_g_object_unref0 (_s_it);
#line 1504 "completion.c"
				}
			}
		}
	}
}

static void
value_completion_init (GValue* value)
{
#line 22 "src/completion.vala"
	value->data[0].v_pointer = NULL;
#line 1516 "completion.c"
}

static void
value_completion_free_value (GValue* value)
{
#line 22 "src/completion.vala"
	if (value->data[0].v_pointer) {
#line 22 "src/completion.vala"
		completion_unref (value->data[0].v_pointer);
#line 1526 "completion.c"
	}
}

static void
value_completion_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 22 "src/completion.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "src/completion.vala"
		dest_value->data[0].v_pointer = completion_ref (src_value->data[0].v_pointer);
#line 1538 "completion.c"
	} else {
#line 22 "src/completion.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1542 "completion.c"
	}
}

static gpointer
value_completion_peek_pointer (const GValue* value)
{
#line 22 "src/completion.vala"
	return value->data[0].v_pointer;
#line 1551 "completion.c"
}

static gchar*
value_completion_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 22 "src/completion.vala"
	if (collect_values[0].v_pointer) {
#line 1562 "completion.c"
		Completion * object;
		object = collect_values[0].v_pointer;
#line 22 "src/completion.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "src/completion.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1569 "completion.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "src/completion.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1573 "completion.c"
		}
#line 22 "src/completion.vala"
		value->data[0].v_pointer = completion_ref (object);
#line 1577 "completion.c"
	} else {
#line 22 "src/completion.vala"
		value->data[0].v_pointer = NULL;
#line 1581 "completion.c"
	}
#line 22 "src/completion.vala"
	return NULL;
#line 1585 "completion.c"
}

static gchar*
value_completion_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	Completion ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "src/completion.vala"
	if (!object_p) {
#line 22 "src/completion.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1600 "completion.c"
	}
#line 22 "src/completion.vala"
	if (!value->data[0].v_pointer) {
#line 22 "src/completion.vala"
		*object_p = NULL;
#line 1606 "completion.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "src/completion.vala"
		*object_p = value->data[0].v_pointer;
#line 1610 "completion.c"
	} else {
#line 22 "src/completion.vala"
		*object_p = completion_ref (value->data[0].v_pointer);
#line 1614 "completion.c"
	}
#line 22 "src/completion.vala"
	return NULL;
#line 1618 "completion.c"
}

GParamSpec*
param_spec_completion (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecCompletion* spec;
#line 22 "src/completion.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_COMPLETION), NULL);
#line 22 "src/completion.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "src/completion.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "src/completion.vala"
	return G_PARAM_SPEC (spec);
#line 1637 "completion.c"
}

gpointer
value_get_completion (const GValue* value)
{
#line 22 "src/completion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPLETION), NULL);
#line 22 "src/completion.vala"
	return value->data[0].v_pointer;
#line 1647 "completion.c"
}

void
value_set_completion (GValue* value,
                      gpointer v_object)
{
	Completion * old;
#line 22 "src/completion.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPLETION));
#line 22 "src/completion.vala"
	old = value->data[0].v_pointer;
#line 22 "src/completion.vala"
	if (v_object) {
#line 22 "src/completion.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMPLETION));
#line 22 "src/completion.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "src/completion.vala"
		value->data[0].v_pointer = v_object;
#line 22 "src/completion.vala"
		completion_ref (value->data[0].v_pointer);
#line 1669 "completion.c"
	} else {
#line 22 "src/completion.vala"
		value->data[0].v_pointer = NULL;
#line 1673 "completion.c"
	}
#line 22 "src/completion.vala"
	if (old) {
#line 22 "src/completion.vala"
		completion_unref (old);
#line 1679 "completion.c"
	}
}

void
value_take_completion (GValue* value,
                       gpointer v_object)
{
	Completion * old;
#line 22 "src/completion.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPLETION));
#line 22 "src/completion.vala"
	old = value->data[0].v_pointer;
#line 22 "src/completion.vala"
	if (v_object) {
#line 22 "src/completion.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMPLETION));
#line 22 "src/completion.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "src/completion.vala"
		value->data[0].v_pointer = v_object;
#line 1700 "completion.c"
	} else {
#line 22 "src/completion.vala"
		value->data[0].v_pointer = NULL;
#line 1704 "completion.c"
	}
#line 22 "src/completion.vala"
	if (old) {
#line 22 "src/completion.vala"
		completion_unref (old);
#line 1710 "completion.c"
	}
}

static void
completion_class_init (CompletionClass * klass,
                       gpointer klass_data)
{
#line 22 "src/completion.vala"
	completion_parent_class = g_type_class_peek_parent (klass);
#line 22 "src/completion.vala"
	((CompletionClass *) klass)->finalize = completion_finalize;
#line 1722 "completion.c"
}

static void
completion_instance_init (Completion * self,
                          gpointer klass)
{
#line 22 "src/completion.vala"
	self->ref_count = 1;
#line 1731 "completion.c"
}

static void
completion_finalize (Completion * obj)
{
	Completion * self;
#line 22 "src/completion.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPLETION, Completion);
#line 22 "src/completion.vala"
	g_signal_handlers_destroy (self);
#line 23 "src/completion.vala"
	_g_free0 (self->match);
#line 24 "src/completion.vala"
	_buffer_unref0 (self->old_bp);
#line 25 "src/completion.vala"
	_g_object_unref0 (self->completions);
#line 26 "src/completion.vala"
	_g_object_unref0 (self->matches);
#line 29 "src/completion.vala"
	_g_free0 (self->path);
#line 1752 "completion.c"
}

static GType
completion_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_completion_init, value_completion_free_value, value_completion_copy_value, value_completion_peek_pointer, "p", value_completion_collect_value, "p", value_completion_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (CompletionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) completion_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Completion), 0, (GInstanceInitFunc) completion_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType completion_type_id;
	completion_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Completion", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return completion_type_id;
}

GType
completion_get_type (void)
{
	static volatile gsize completion_type_id__once = 0;
	if (g_once_init_enter (&completion_type_id__once)) {
		GType completion_type_id;
		completion_type_id = completion_get_type_once ();
		g_once_init_leave (&completion_type_id__once, completion_type_id);
	}
	return completion_type_id__once;
}

gpointer
completion_ref (gpointer instance)
{
	Completion * self;
	self = instance;
#line 22 "src/completion.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "src/completion.vala"
	return instance;
#line 1787 "completion.c"
}

void
completion_unref (gpointer instance)
{
	Completion * self;
	self = instance;
#line 22 "src/completion.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "src/completion.vala"
		COMPLETION_GET_CLASS (self)->finalize (self);
#line 22 "src/completion.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1801 "completion.c"
	}
}

